tree grammar calc5Tree;

options {
    tokenVocab=calc5;
    ASTLabelType=CommonTree;
}

@header {
import java.lang.Double;
import java.lang.Math;
}

@members {
boolean unary;
}

calc
    : (expr)+
    ;

expr
    : ^(PLUS e1=expr {unary = true;} (e2=expr {unary = false;})?)  {System.out.println(unary ? "uplus" : "add");}
    | ^(MINUS e1=expr {unary = true;} (e2=expr {unary = false;})?) {System.out.println(unary ? "uminus" : "sub");}
    | ^(MULT e1=expr e2=expr)   {System.out.println("mul");}
    | ^(DIV e1=expr e2=expr)    {System.out.println("div");}
    | ^(POW e1=expr e2=expr)    {System.out.println("pow");}
    | DOUBLE                    {System.out.println("push " + $DOUBLE.text);}
    | PI                        {System.out.println("push " + Math.PI);}
    | E                         {System.out.println("push " + Math.E);}
    ;
